#ifndef STOCK_H

#define STOCK_H

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <signal.h>
#include <string.h>
#include <sys/types.h>

#define SIZE 4 
/* SIZE is used to decide the value of arguements passed to 
 * size specific code, for eg. sockets.
 * this is defined 4 directly here, however, later with use of
 * preprocessor inclusions etc., it should be used to produce more
 * portable code.. for the moment, we assume all ints.
 */

typedef int32_t plid_t;
typedef int32_t cid_t; 
typedef int32_t grid_t;
typedef u_int32_t pr_t;
typedef int32_t qty_t;
typedef unsigned char req_t;
typedef int32_t slot_t;
typedef int32_t passwd_t;
typedef u_int32_t cash_t;

#define PORTNUM 5000
#define HASHSIZE 5
#define UPDATE_INTERVAL 1
#define TOLERANCE 5

#include "services.h"
#include "socket.h"
#include "players.h"
#include "companies.h"

#define MALLOC_CHECK_ 2
/* socket.c */
void sock_read (int socket, void *buf, int cnt);
void sock_write (int socket, void *buf, int cnt);
char *sock_read_string (int socket);
void sw_int (int socket, int s);
void sw_s_int (int socket, int16_t s);

#endif /* STOCK_H */
