#include "stock.h"
#include <errno.h>
#include "threads.h"

req_list_t *head_req_list;
req_list_t *tail_req_list;
plid_t player_simult_tot, player_tot;
pthread_mutex_t player_tot_mut;

void *trader () {

   while (1) {
      if (head_req_list == tail_req_list) {
	 sleep (1);
	 continue;
      }
      
      (*(head_req_list->call_fn)) (player[head_req_list->plid].client2, 
			      head_req_list->plid, 
			      head_req_list->cid,
			      head_req_list->pr, 
			      head_req_list->qty );
      
      
      /* I figure that head_req_list shouldn't be protected by the
       * req_list_mut because the opearations are quite safe..
       * head_req_list is manipulated only here in one place ..
       */
      head_req_list = head_req_list->next;
   }
}

void *cleaner () {
   
   while (1) {
      register int i;
      
      sleep (admin_interval);
      
      for (i=1; i<=player_tot; ++i) {
	 player_t *p = &player[i];
	 
	 if (p->client > 0) {
	 
	    if ((pthread_detach (*p->sync_th) == ESRCH) &&
		(pthread_detach (*p->async_th) == ESRCH)) {
	       
#ifdef DEBUG
	       printf ("cleaner : cleaning for player %d\n", i);
#endif
	       
#ifdef DEBUG
	       fprintf (logfile, "plid %d logged out\n", i);
#endif
	       free (p->sync_th);
	       free (p->async_th);
	       p->client = -1;  /* Now we are ready for logging in again */
	       
	       pthread_mutex_lock (&player_tot_mut);
	       --player_simult_tot;
	       pthread_mutex_unlock (&player_tot_mut);
	       
	    } 
	    
	    if (++p->timeout == 0) {
#ifdef LOG
	       fprintf (logfile, "plid %d timed out\n", i);
#endif
	       close (p->client);
	       close (p->client2);
	       pthread_cancel (*p->sync_th);
	       pthread_cancel (*p->async_th);
	    }
	 }
	 
	 
      } /* for (i=1 ...) */
   }  /* while (1) */
}   /* cleaner () */

